*L+
;Modu DSKHNDLR.FDCBETA1 (Beta Disk 128, do ROM)
;Ostatnia modyfikacja: 03-05-20; (C) Jarek Adamski
*L-
;030520	usunite przechowanie DE, jeli w ROM
;991117	przystosowanie do umieszcznia w ROM
;991103	zacztek z FDCTMX oraz drivera do NeOS; (C) Jarek Adamski

;(IX=^data,A=function,B,DE,HL)(A,BC,DE,HL,IX=?)
;init	(A=0,B=,D=,E=,HL=^buffer)(A=err,B=units,DE=mask,HL^=text)
;setup	(A=1,B=,D=,E=,H=gap3,L=)(A=err)
;read	(A=2,B=side,C=unit,D=track,E=sector,HL=^buffer)(A=err)
;write	(A=3,B=side,C=unit,D=track,E=sector,HL=^buffer)(A=err)
;check	(A=4,B=side,C=unit,D=track,E=sector,HL=^buffer)(A=err)
;format	(A=5,B=side,C=unit,D=track,E=sectors,HL=^IDtab)(A=err)

fbfw	EQU	#E5		;wypeniacz formatowanego sektora

;obecnie numer funkcji podaje si w A
fbhere	JP	fbnext		;wejcie przerwa ignorowane
	JP	fbmain		;wejcie uytkowe
	DEFW	#7002		;numer wersji
	DEFW	fbnext-fbhere,fbhere,fbtbl1-fbtbl0,fbtbl0
	DEFM	'DSKHNDLR'
	DEFM	'FDCBETA1'
fbtbl0	DEFB	0,#18,#3C,0,0,0,0,0
	DEFB	0,#18,#3D,0,0,0,0,0
	DEFB	0,#18,#3E,0,0,0,0,0
	DEFB	0,#18,#3F,0,0,0,0,0
fbtbl1	EQU	$
fbmain	AND	#0F		;funkcje 4..15 nie implementowane
	JR	NZ,fbrwop
;inicjacja
	COND	dskhnd & 1	;czy w ROM
	PUSH	HL		;inicjacja tabeli standardowymi wartociami
	PUSH	IX		;IX podane przy wywoaniu
	POP	DE
	LD	HL,fbtbl0
	LD	BC,fbtbl1-fbtbl0
	LDIR
	POP	HL
	ENDC
	LD	BC,#0018	;wskazanie na opis ostatniego napdu
	ADD	IX,BC
	LD	B,#04
fbinit1	LD	A,(IX+2)
;	LD	A,#5F
;	OUT	(#E0),A
	OUT	(#FF),A		;#E0
	LD	A,(IX+1)
	AND	#0F
	OUT	(#1F),A		;#C0;gowica na ciek 0
	LD	DE,#0200
	LD	(IX),E		;gowica na ciece 0
	LD	(IX+3),#18	;=Gap3 - napd niby jest
fbinit2	IN	A,(#1F)		;#C0
	BIT	2,A		;test TRK0
	JR	NZ,fbinit3	;jest TRK0
	DEC	DE
	LD	A,E
	OR	D
	JR	NZ,fbinit2
	LD	(IX+3),E	;zmiana na #00 - napdu nie ma
fbinit3	LD	DE,-#0008
;	CALL	fboff		;cieka zapamitana, ale czy gasi wiato???
	ADD	IX,DE
	DJNZ	fbinit1
;ma zwraca mask napdw w DE i ich ilo w B
	XOR	A
	RET

fbrwop	PUSH	AF
	LD	A,C
	ADD	A,A		;wybranie napdu o numerze w A
	ADD	A,A
	ADD	A,A		;jest *8
	AND	#18
	DEFB	#DD		;IX podane przy wywoaniu
	ADD	A,L
	DEFB	#DD
	LD	L,A
	DEFB	#DD
	ADC	A,H		;doda starszy bajt adresu tabeli
	DEFB	#DD
	SUB	L
	DEFB	#DD
	LD	H,A		;wyliczenie IX dla podanego napdu
	POP	AF
	DEC	A
	JR	NZ,fbrwop1
	LD	(IX+3),H	;inicjacja H=gap3
	RET
fbrwop1	PUSH	AF
	CALL	fbini
	POP	BC		;B=numer funkcji
	CALL	Z,fbread	;CALL w celu moliwoci wyjcia z fbwait
fboff	PUSH	AF
	IN	A,(#3F)		;#C1
	LD	(IX),A		;zapamitanie cieki
;	LD	A,#DF
;	OUT	(#E0),A
;	AND	(IX+2)
;	OR	#80
;	OUT	(#FF),A		;#FF;to bdzie inaczej
;	LD	A,#5F
;	OUT	(#E0),A
	POP	AF
	RET


fbread	DJNZ	fbwrit
fbg0	LD	A,#80
	CALL	fbwait
	INI
fbg1	IN	A,(#1F)		;#C0
	RRA
	JR	NC,fbg2
	RRA
	JR	NC,fbg1
	INI
	JR	fbg1
fbg2	AND	#1C/2
	RET

fbwrit	DJNZ	fbchck
fbp0	LD	A,#A0
	CALL	fbwait
	OUTI	
fbp1	IN	A,(#1F)		;#C0
	RRA
	JR	NC,fbp2
	RRA
	JR	NC,fbp1
	OUTI	
	JR	fbp1
fbp2	AND	#5C/2
	RET

fbchck	DJNZ	fbform
fbc0	LD	A,#80
	CALL	fbwait
	JR	fbc2
fbc1	IN	A,(#1F)		;#C0
	RRA
	JR	NC,fbg2
	RRA
	JR	NC,fbc1
fbc2	IN	A,(#7F)		;#C3
	CP	(HL)
	INC	HL
	JR	Z,fbc1
	XOR	A
	RET

	COND	dskhnd&#20	;czy ma by formatowanie
fbform	OR	#FF		;nie ma formatowania
	RET
	ELSE
fbform	DEC	B
	JP	NZ,fbnic
fbf0	PUSH	DE
	LD	A,#F0		;formatowanie bdzie inaczej
	CALL	fbwait
	POP	DE
	LD	B,E		;ilo sektorw
	LD	D,#28		;Gap 1
fbf1	PUSH	BC
	CALL	fbfsec
	POP	BC
	RET	NZ
	LD	D,(IX+3)	;Gap 3
	DJNZ	fbf1
	LD	DE,#004E	;Gap 4
	CALL	fbfgap
	XOR	A
	RET

fbfgap	CALL	fbfj		;ze wzgldu na fbferr
	RET
fbfsec	LD	E,#4E		;Gap 1 albo Gap 3
	CALL	fbfj
	LD	DE,#0C00	;rozbiegwka
	CALL	fbfj
	LD	DE,#03F5	;zapis #A1
	CALL	fbfj
	LD	DE,#01FE	;znacznik adresu ID
	CALL	fbfj
	LD	B,#04		;zapis ID
	CALL	fbfm
	LD	DE,#01F7	;zapis CRC
	CALL	fbfj
	LD	DE,#164E	;Gap 2 - zawsze 22 bajty
	CALL	fbfj
	LD	DE,#0C00	;rozbiegwka
	CALL	fbfj
	LD	DE,#03F5	;zapis #A1
	CALL	fbfj
	LD	DE,#01FB	;znacznik adresu danych
	CALL	fbfj
	DEC	HL
	LD	B,(HL)
	LD	DE,#8000+fbfw	;sektor 128B, E-wypeniacz sektora
	CALL	fbfj
	INC	B
	DEC	B
	JR	Z,fbfcrc
	LD	D,#80		;sektor 256B
	CALL	fbfj
	DEC	B
	JR	Z,fbfcrc
	CALL	fbfj		;sektor 512B
	DEC	B
	JR	Z,fbfcrc
	CALL	fbfj		;sektor 1KB
	CALL	fbfj
fbfcrc	INC	HL
	LD	DE,#01F7
fbfj	IN	A,(#1F)		;#C0;wysanie D jednakowych bajtw E
	RRA
	RET	NC		;bd Z=0
	RRA
	JR	NC,fbfj
	OUT	(C),E
	DEC	D
	JP	NZ,fbfj
	RET			;ok: Z=0


fbfm	IN	A,(#1F)		;#C0;wysanie bajtw spod adresu
	RRA
	JR	NC,fbferr	;bd: Z=0
	RRA
	JR	NC,fbfm		;oczekiwanie na moliwo
	OUTI
	JP	NZ,fbfm		;skok, gdy B>0
	RET			;ok: Z=1
	
fbferr	POP	AF
	IN	A,(#1F)		;#C0
	AND	#7C
	RET
fbnic	OR	#FF
	RET
	ENDC

fbini	LD	A,(IX+3)	;FGAP albo 0, jeli nie ma napdu
	AND	A
	JR	Z,fbnodr	;nie ma takiego napdu!
;	LD	A,#5F
;	OUT	(#E0),A
	LD	C,(IX+2)
	BIT	0,B		;strona
	JR	Z,fbini2
	RES	4,C		;=0 - druga strona
fbini2	LD	A,C
	OUT	(#FF),A		;#E0;drive & side select
	LD	A,E
	OUT	(#5F),A		;#C2;sektor
	LD	A,(IX)
	OUT	(#3F),A		;#C1
	CP	D
	RET	Z
	LD	A,D
	AND	A
	JR	Z,fbhome
	OUT	(#7F),A		;#C3;cylinder
	LD	A,(IX+1)	;komenda przesuwu gowicy
	CALL	fbcom
	AND	#10
	RET	Z
	JR	fberr		;tak jest w SAMie

fbwait	OUT	(#1F),A		;#C0
	LD	B,#10
fbw1	DJNZ	fbw1
	DI			;przerwania generuj WD1770 i WD2123
	LD	DE,#0000
	LD	BC,#027F	;#C3
fbdw2	IN	A,(#1F)		;#C0;zamieni na #C0
	AND	#02
	RET	NZ
	DEC	DE
	LD	A,E
	OR	D
	JR	NZ,fbdw2
	DJNZ	fbdw2
	POP	AF		;to powoduje problemy
fberr	CALL	fbhome
fbnodr	OR	#FF
	RET

fbhome	LD	A,(IX+1)	;komenda przesuwu gowicy
	AND	#0F
fbcom	OUT	(#1F),A		;#C0;!!! tu jest wie - but why???
fbcom1	LD	A,#07
fbcom2	DEC	A
	JR	NZ,fbcom2
	IN	A,(#1F)		;#C0
	BIT	0,A
	RET	Z
	JR	fbcom1
;	LD	A,#D0		;Force Interrupt - dziaa zawsze
;	JR	fbcom


fbnext	EQU	$		;wejcie przerwa nastpnego
;
;	End of file DSKHNDLR.FDCBETA1.GI
;
