;*L+
;DSKHNDLR.ZXIDE128 - dyski IDE w portach #2B..#EF, dostp 16b
;Ostatnia modyfikacja: 03-05-20; (C) Jarek Adamski
;*L-

;	rozmiar dysku odczytywany komend dysku
;020516	zliczanie partycji o przesuniciach <#FFFF
;021127	konflikt portw z FDC MB02
;021122 na podstawie ATBUS.GI; (C) Jarek Adamski
;
i1mins	EQU	30		;ilo minut do automatycznego parkowania

i1here	JP	i1inte		;wejcie przerwa - co 1s
	JP	i1main
	DEFW	#A002		;numer wersji
	DEFW	i1next-i1here,i1here,i1part1-i1part,i1part
	DEFM	'DSKHNDLR'
	DEFM	'ZXIDE128'
;
;przesunicia w cylindrach poszczeglnych partycji obu dyskw,
;naley je ustawi na pocztku
i1part	DEFW	#0000,#FFFF,#FFFF,#FFFF
	DEFW	#FFFF,#FFFF,#FFFF,#FFFF
	DEFW	#FFFF,#FFFF,#FFFF,#FFFF
	DEFW	#FFFF,#FFFF,#FFFF,#FFFF
	DEFW	#0000,#FFFF,#FFFF,#FFFF
	DEFW	#FFFF,#FFFF,#FFFF,#FFFF
	DEFW	#FFFF,#FFFF,#FFFF,#FFFF
	DEFW	#FFFF,#FFFF,#FFFF,#FFFF
i1time	DEFW	60*i1mins
i1part1	EQU	$

;procedura obsugujca przerwanie (nie wymagane przechowanie rejestrw AF,HL)
i1inte	DEC	(IX+i1time-i1part)
	JP	NZ,i1next
	DEC	(IX+i1time-i1part+1)
	LD	A,#E0		;komenda >HDPARK<
	CALL	Z,i1com
	JP	i1next		;przekazanie przerwania do nastpnego moduu


;komenda
i1com	PUSH	AF
i1com1	IN	A,(#EF)		;#B7
	AND	A
	JP	M,i1com1	;zaptlenie do uzyskania gotowoci; JP szybciej
	POP	AF		;w A komenda
	OUT	(#EF),A		;#B7, wysanie komendy
i1com2	IN	A,(#EF)		;#B7
	BIT	7,A
	JP	NZ,i1com2	;zaptlenie do uzyskania gotowoci; JP szybciej
	AND	#25		;maska bdw
	RET
;wybieranie waciwego sektora
i1ini	PUSH	HL
	LD	HL,60*i1mins	;czas do zaparkowania
	LD	(IX+i1time-i1part+0),L
	LD	(IX+i1time-i1part+1),H
i1ini1	IN	A,(#EF)		;#B7
	BIT	7,A
	JR	NZ,i1ini1
	LD	A,C
	AND	#10		;Master lub Slave
	OR	B		;mamy unit, dodajemy stron
	OR	#A0		;sygnaturka (podobno)
	OUT	(#EB),A		;#B6, wybieramy dysk i stron
i1ini2	IN	A,(#EF)		;#B7
	BIT	7,A
	JR	NZ,i1ini2
	LD	A,#01
	OUT	(#6B),A		;#B2, ilo sektorw
	LD	A,E
	OUT	(#6F),A		;#B3, numer sektora
	LD	A,C		;w C numer partycji (po 16 na dysk)
	AND	#1F
	ADD	A,A
	LD	C,A
	LD	B,#00
	ADD	IX,BC		;pobranie przesunicia partycji
	LD	A,(IX+0)
	ADD	A,D		;cylinder
	OUT	(#AB),A		;#B4, LO cieki
	LD	A,(IX+1)
	ADC	A,#00		;dodanie przeniesienia
	OUT	(#AF),A		;#B5, HI cieki
	POP	HL
	RET


i1want	LD	B,A		;komenda wymaga gotowoci, przechowana w B
i1wan1	IN	A,(#EF)		;#B7
	RLCA
	JP	C,i1wan1	;zaptlenie do uzyskania gotowoci; JP szybciej
	LD	A,B		;w A komenda
	OUT	(#EF),A		;#B7
	LD	BC,#802B	;#B0 port danych
i1wan2	IN	A,(#EF)		;#B7
	AND	A
	JP	M,i1wan2
	BIT	3,A
	RET	NZ
	AND	#25		;maska bdu
	JR	Z,i1wan2	;bez bdu
	POP	AF		;bd
	RET


i1main	AND	#0F
	JR	NZ,i1info
	COND	dskhnd & #0001
	BIT	4,C		;not for #B0 initiation
	JR	NZ,i1init
;	PUSH	HL		;needed to read IDE identification data
	LD	HL,i1part
	PUSH	IX
	POP	DE
	LD	BC,i1part1-i1part
	LDIR
;	POP	HL
	ENDC
i1init	LD	DE,#0000	;zwraca: B-ilo partycji, DE-maska
	LD	B,E
i1i1	DEC	DE
	LD	A,E
	OR	D
	RET	Z
	IN	A,(#EF)		;#B7
	RLCA
	JR	C,i1i1
i1i2	LD	A,B
	OUT	(#AB),A		;#B4
	IN	A,(#AB)		;#B4
	CP	B
	JR	NZ,i1inic
	DJNZ	i1i2
;	LD	A,#02
;	OUT	(#FF),A		;#BE nie ma
;	LD	A,#10
;	OUT	(#EF),A		;#B7
	PUSH	IX		;count partitons with shifts <#FFFF
	POP	HL
	LD	BC,#1000
i1i3	LD	A,(HL)		;test for #FFFF
	INC	HL
	AND	(HL)
	INC	HL
	CP	#FF		;resets Cy only when #FF was
	JR	NC,i1i4
	INC	C		;Cy not changed
i1i4	RR	D
	RR	E
	DJNZ	i1i3
	LD	B,C
	RET
i1inic	LD	DE,0
	LD	B,E
	RET

i1info	DEC	A		;funkcja 1 - ustawienie przesunicia partycji
	JR	NZ,i1read
	LD	A,C		;w C numer partycji (po 16 na dysk)
	AND	#1F
	ADD	A,A
	LD	C,A
	LD	B,#00
	ADD	IX,BC		;ustalenie przesunicia partycji
	LD	(IX+0),L
	LD	(IX+1),H
;	LD	BC,#C401	;odczyta to z RDSK/PART!
;	LD	DE,#0411	;D-strony, E-sektory
	LD	HL,#0200	;wielko sektora
	RET
i1read	PUSH	AF
	CALL	i1ini		;zawsze poprawnie
	POP	BC
	JP	i1cd
i1cd	DJNZ	i1writ
i1g0	LD	A,#20
	CALL	i1want
i1g1	INI
	INI
	INI
	INI
	DJNZ	i1g1
i1g2	IN	A,(#EF)		;#B7
	AND	#01
	RET
i1writ	DJNZ	i1chck
i1p0	LD	A,#30
	CALL	i1want
	INC	B
i1p1	INC	HL
	OUTD
	OUTI
	INC	HL
	INC	HL
	OUTD
	OUTI
	INC	HL
	DJNZ	i1p1
i1p2	IN	A,(#EF)		;#B7
	AND	#21
	RET

i1chck	DJNZ	i1form
i1v0	LD	A,#20
	CALL	i1want
i1v1	IN	A,(C)		;A8=0 modszy bajt (z dysku)
	SUB	(HL)
	JR	NZ,i1bad	;jeli le, to A<>0
	INC	HL
	DEC	B
	IN	A,(C)		;A8=1 starszy bajt (z bufora)
	SUB	(HL)
	JR	NZ,i1bad
	INC	HL
	DEC	B
i1v2	IN	A,(#EF)		;#B7
	AND	A
	JP	M,i1v2
	BIT	3,A
	JP	NZ,i1v1
	AND	#01
	RET

i1bad	RET

i1form	OR	#FF		;formatowania nie bdzie
	RET

i1next	EQU	$		;wejcie przerwa do nastpnego urzdzenia

;
;	End of file DSKHNDLR.ZXIDE128.GI
;
